Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.1.1.3.4.6.2.4
retrieving revision 1.1.1.3.4.6.2.4.2.1
diff -u -r1.1.1.3.4.6.2.4 -r1.1.1.3.4.6.2.4.2.1
--- squid/src/client_side.c	10 Jul 2001 19:42:13 -0000	1.1.1.3.4.6.2.4
+++ squid/src/client_side.c	27 Aug 2001 21:48:20 -0000	1.1.1.3.4.6.2.4.2.1
@@ -2858,16 +2880,8 @@
 	    continue;
 	}
 	enter_suid();
-	fd = comm_open(SOCK_STREAM,
-#ifdef _SQUID_MSWIN_
-	    IPPROTO_TCP,
-#else
-	    0,
-#endif
-	    s->s.sin_addr,
-	    ntohs(s->s.sin_port),
-	    COMM_NONBLOCKING,
-	    "HTTP Socket");
+	fd = comm_open(SOCK_STREAM, 0, s->s.sin_addr,
+	    ntohs(s->s.sin_port), COMM_NONBLOCKING, "HTTP Socket");
 	leave_suid();
 	if (fd < 0)
 	    continue;
@@ -2879,9 +2893,7 @@
 	 */
 	commSetDefer(fd, httpAcceptDefer, NULL);
 	debug(1, 1) ("Accepting HTTP connections at %s, port %d, FD %d.\n",
-	    inet_ntoa(s->s.sin_addr),
-	    (int) ntohs(s->s.sin_port),
-	    fd);
+	    inet_ntoa(s->s.sin_addr), (int) ntohs(s->s.sin_port), fd);
 	HttpSockets[NHttpSockets++] = fd;
     }
     if (NHttpSockets < 1)
Index: squid/src/comm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm.c,v
retrieving revision 1.1.1.3.4.1.2.5
retrieving revision 1.1.1.3.4.1.2.5.2.1
diff -u -r1.1.1.3.4.1.2.5 -r1.1.1.3.4.1.2.5.2.1
--- squid/src/comm.c	29 Jul 2001 16:06:05 -0000	1.1.1.3.4.1.2.5
+++ squid/src/comm.c	27 Aug 2001 21:48:20 -0000	1.1.1.3.4.1.2.5.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: comm.c,v 1.1.1.3.4.1.2.5 2001/07/29 16:06:05 serassio Exp $
+ * $Id: comm.c,v 1.1.1.3.4.1.2.5.2.1 2001/08/27 21:48:20 tolsty Exp $
  *
  * DEBUG: section 5     Socket Functions
  * AUTHOR: Harvest Derived
@@ -40,7 +39,8 @@
 #include <netinet/tcp.h>
 #endif
 
-typedef struct {
+typedef struct
+{
     char *host;
     u_short port;
     struct sockaddr_in S;
@@ -52,7 +52,8 @@
     int tries;
     int addrcount;
     int connstart;
-} ConnectStateData;
+}
+ConnectStateData;
 
 /* STATIC */
 static int commBind(int s, struct in_addr, u_short port);
@@ -73,7 +74,8 @@
 
 #ifdef _SQUID_MSWIN_
 void
-commSetSelectS(int sd, unsigned int type, PF * handler, void *client_data, time_t timeout)
+commSetSelectS(int sd, unsigned int type, PF * handler, void *client_data,
+    time_t timeout)
 {
     sde *F = &sd_table[sd];
     assert(sd >= 0);
@@ -125,8 +127,7 @@
 }
 
 /* Return the local port associated with fd. */
-u_short
-comm_local_port(int fd)
+u_short comm_local_port(int fd)
 {
     struct sockaddr_in addr;
     socklen_t addr_len = 0;
@@ -145,7 +146,10 @@
 	return F->local_port;
     addr_len = sizeof(addr);
     if (getsockname(fd, (struct sockaddr *) &addr, &addr_len)) {
-	debug(50, 1) ("comm_local_port: Failed to retrieve TCP/UDP port number for socket: FD %d: %s\n", fd, xstrerror());
+	debug(50, 1)
+	    
+	    ("comm_local_port: Failed to retrieve TCP/UDP port number for socket: FD %d: %s\n",
+	    fd, xstrerror());
 	return 0;
     }
     F->local_port = ntohs(addr.sin_port);
@@ -168,8 +172,7 @@
     debug(50, 0) ("commBind: Cannot bind socket FD %d to %s:%d: %s\n",
 	s,
 	S.sin_addr.s_addr == INADDR_ANY ? "*" : inet_ntoa(S.sin_addr),
-	(int) port,
-	xstrerror());
+	(int) port, xstrerror());
     return COMM_ERROR;
 }
 
@@ -177,31 +180,17 @@
  * is OR of flags specified in comm.h. */
 int
 comm_open(int sock_type,
-    int proto,
-    struct in_addr addr,
-    u_short port,
-    int flags,
-    const char *note)
+    int proto, struct in_addr addr, u_short port, int flags, const char *note)
 {
     int new_socket;
 #ifdef _SQUID_MSWIN_
     sde *F = NULL;
-    int err;
 #else
     fde *F = NULL;
 #endif
 
     /* Create socket for accepting new connections. */
     Counter.syscalls.sock.sockets++;
-#ifdef _SQUID_MSWIN_
-    if ((new_socket = socket(AF_INET, sock_type, proto)) == INVALID_SOCKET) {
-	/* Increase the number of reserved fd's if calls to socket()
-	 * are failing because the open file table is full.  This
-	 * limits the number of simultaneous clients */
-	err=WSAGetLastError();
-	switch (err) {
-	case WSAEMFILE:
-#else
     if ((new_socket = socket(AF_INET, sock_type, proto)) < 0) {
 	/* Increase the number of reserved fd's if calls to socket()
 	 * are failing because the open file table is full.  This
@@ -209,7 +198,6 @@
 	switch (errno) {
 	case ENFILE:
 	case EMFILE:
-#endif
 	    debug(50, 1) ("comm_open: socket failure: %s\n", xstrerror());
 	    fdAdjustReserved();
 	    break;
@@ -232,9 +220,9 @@
 	commSetReuseAddr(new_socket);
     if (port > (u_short) 0) {
 #ifdef _SQUID_MSWIN_
-	if ( sock_type != SOCK_DGRAM && proto != IPPROTO_UDP )
+	if (sock_type != SOCK_DGRAM)
 #endif
-	commSetNoLinger(new_socket);
+	    commSetNoLinger(new_socket);
 	if (opt_reuseaddr)
 	    commSetReuseAddr(new_socket);
     }
@@ -271,15 +259,15 @@
     int x;
     if ((x = listen(sock, Squid_MaxFD >> 2)) < 0) {
 	debug(50, 0) ("comm_listen: listen(%d, %d): %s\n",
-	    Squid_MaxFD >> 2,
-	    sock, xstrerror());
+	    Squid_MaxFD >> 2, sock, xstrerror());
 	return x;
     }
     return sock;
 }
 
 void
-commConnectStart(int fd, const char *host, u_short port, CNCB * callback, void *data)
+commConnectStart(int fd, const char *host, u_short port, CNCB * callback,
+    void *data)
 {
     ConnectStateData *cs = xcalloc(1, sizeof(ConnectStateData));
     debug(5, 3) ("commConnectStart: FD %d, %s:%d\n", fd, host, (int) port);
@@ -352,50 +340,28 @@
 static int
 commResetFD(ConnectStateData * cs)
 {
-#ifdef _SQUID_MSWIN_
-    int err;
-#endif
     int fd2;
     if (!cbdataValid(cs->data))
 	return 0;
-#ifdef _SQUID_MSWIN_
-    closesocket(cs->fd);
-    return 0;
-#endif
     Counter.syscalls.sock.sockets++;
     fd2 = socket(AF_INET, SOCK_STREAM, 0);
     Counter.syscalls.sock.sockets++;
     if (fd2 < 0) {
-#ifdef _SQUID_MSWIN_
-	err=WSAGetLastError();
-#endif
 	debug(5, 0) ("commResetFD: socket: %s\n", xstrerror());
-#ifdef _SQUID_MSWIN_
-	if (WSAEMFILE == h_errno)
-#else
 	if (ENFILE == errno || EMFILE == errno)
-#endif
 	    fdAdjustReserved();
 	return 0;
     }
     if (dup2(fd2, cs->fd) < 0) {
-#ifdef _SQUID_MSWIN_
-	err=WSAGetLastError();
-#endif
 	debug(5, 0) ("commResetFD: dup2: %s\n", xstrerror());
-#ifdef _SQUID_MSWIN_
-	if (WSAEMFILE == err)
-#else
 	if (ENFILE == errno || EMFILE == errno)
-#endif
 	    fdAdjustReserved();
 	return 0;
     }
+    close(fd2);
 #ifdef _SQUID_MSWIN_
-    closesocket(fd2);
     sd_table[cs->fd].flags.called_connect = 0;
 #else
-    close(fd2);
     fd_table[cs->fd].flags.called_connect = 0;
 #endif
     /*
@@ -420,6 +386,7 @@
 static int
 commRetryConnect(ConnectStateData * cs)
 {
+//#error What's with tries & timeout?
     assert(cs->addrcount > 0);
     if (cs->addrcount == 1) {
 	if (cs->tries >= Config.retry.maxtries)
@@ -485,9 +452,9 @@
     assert(fd >= 0);
     assert(fd < Squid_MaxFD);
 #ifdef _SQUID_MSWIN_
-	F = &sd_table[fd];
+    F = &sd_table[fd];
 #else
-	F = &fd_table[fd];
+    F = &fd_table[fd];
 #endif
     assert(F->flags.open);
     if (timeout < 0) {
@@ -523,14 +490,7 @@
 	Counter.syscalls.sock.connects++;
 	x = connect(sock, (struct sockaddr *) address, sizeof(*address));
 	if (x < 0)
-#ifdef _SQUID_MSWIN_
-	{
-	    err=WSAGetLastError();
-	    debug(5, 9) ("connect FD %d: %s\n", sock, wsastrerror(err));
-	}
-#else
 	    debug(5, 9) ("connect FD %d: %s\n", sock, xstrerror());
-#endif
     } else {
 #if defined(_SQUID_NEWSOS6_)
 	/* Makoto MATSUSHITA <matusita@ics.es.osaka-u.ac.jp> */
@@ -543,11 +503,7 @@
 	}
 #else
 	errlen = sizeof(err);
-#ifdef _SQUID_MSWIN_
-	x = getsockopt(sock, SOL_SOCKET, SO_ERROR, (char*)&err,(int*) &errlen);
-#else
-	x = getsockopt(sock, SOL_SOCKET, SO_ERROR, &err, &errlen);
-#endif
+	x = getsockopt(sock, SOL_SOCKET, SO_ERROR, (char *) &err, &errlen);
 	if (x == 0)
 	    errno = err;
 #if defined(_SQUID_SOLARIS_)
@@ -562,15 +518,9 @@
 #endif
 #endif
     }
-#ifdef _SQUID_MSWIN_
-    if (err == 0 || err == WSAEISCONN)
-	status = COMM_OK;
-    else if (WSASetLastError(err), ignoreErrno(err))
-#else
     if (errno == 0 || errno == EISCONN)
 	status = COMM_OK;
     else if (ignoreErrno(errno))
-#endif
 	status = COMM_INPROGRESS;
     else
 	return COMM_ERROR;
@@ -601,20 +551,11 @@
 #endif
     Slen = sizeof(P);
     Counter.syscalls.sock.accepts++;
-#ifdef _SQUID_MSWIN_
-    if ((sock = WSAAccept(fd, (struct sockaddr *) &P,(int*) &Slen,NULL,0)) ==INVALID_SOCKET ) {
-	if (ignoreErrno(h_errno)) {
-#else
     if ((sock = accept(fd, (struct sockaddr *) &P, &Slen)) < 0) {
 	if (ignoreErrno(errno)) {
-#endif
 	    debug(50, 5) ("comm_accept: FD %d: %s\n", fd, xstrerror());
 	    return COMM_NOMESSAGE;
-#ifdef _SQUID_MSWIN_
-	} else if (WSAEMFILE == WSAGetLastError()) {
-#else
 	} else if (ENFILE == errno || EMFILE == errno) {
-#endif
 	    debug(50, 3) ("comm_accept: FD %d: %s\n", fd, xstrerror());
 	    return COMM_ERROR;
 	} else {
@@ -633,9 +574,9 @@
     /* fdstat update */
     fd_open(sock, FD_SOCKET, "HTTP Request");
 #ifdef _SQUID_MSWIN_
-	F = &sd_table[sock];
+    F = &sd_table[sock];
 #else
-	F = &fd_table[sock];
+    F = &fd_table[sock];
 #endif
     xstrncpy(F->ipaddr, inet_ntoa(P.sin_addr), 16);
     F->remote_port = htons(P.sin_port);
@@ -670,11 +611,7 @@
 {
     LOCAL_ARRAY(char, buf, 1024);
     int n;
-#ifdef _SQUID_MSWIN_
-    n = recv(fd, buf, 1024);
-#else
     n = read(fd, buf, 1024);
-#endif
     if (n < 0)
 	debug(5, 3) ("commLingerClose: FD %d read: %s\n", fd, xstrerror());
     comm_close(fd);
@@ -719,9 +656,9 @@
     assert(fd >= 0);
     assert(fd < Squid_MaxFD);
 #ifdef _SQUID_MSWIN_
-	F = &sd_table[fd];
+    F = &sd_table[fd];
 #else
-	F = &fd_table[fd];
+    F = &fd_table[fd];
 #endif
     if (F->flags.closing)
 	return;
@@ -735,21 +672,14 @@
     if (F->uses)		/* assume persistent connect count */
 	pconnHistCount(1, F->uses);
     fd_close(fd);		/* update fdstat */
-#ifdef _SQUID_MSWIN_
-    closesocket(fd);
-#else
     close(fd);
-#endif
     Counter.syscalls.sock.closes++;
 }
 
 /* Send a udp datagram to specified TO_ADDR. */
 int
 comm_udp_sendto(int fd,
-    const struct sockaddr_in *to_addr,
-    int addr_len,
-    const void *buf,
-    int len)
+    const struct sockaddr_in *to_addr, int addr_len, const void *buf, int len)
 {
     int x;
     Counter.syscalls.sock.sendtos++;
@@ -758,18 +688,9 @@
 #ifdef _SQUID_LINUX_
 	if (ECONNREFUSED != errno)
 #endif
-#ifdef _SQUID_MSWIN_
-	errno = WSAGetLastError();
-#endif
 	    debug(50, 1) ("comm_udp_sendto: FD %d, %s, port %d: %s\n",
-		fd,
-		inet_ntoa(to_addr->sin_addr),
-		(int) htons(to_addr->sin_port),
-#ifdef _SQUID_MSWIN_
-		wsastrerror(errno));
-#else
-		xstrerror());
-#endif
+		fd, inet_ntoa(to_addr->sin_addr),
+		(int) htons(to_addr->sin_port), xstrerror());
 	return COMM_ERROR;
     }
     return x;
@@ -788,7 +709,8 @@
 }
 
 void
-commSetSelect(int fd, unsigned int type, PF * handler, void *client_data, time_t timeout)
+commSetSelect(int fd, unsigned int type, PF * handler, void *client_data,
+    time_t timeout)
 {
     fde *F = &fd_table[fd];
     assert(fd >= 0);
@@ -816,7 +738,7 @@
     debug(5, 5) ("comm_add_close_handler: FD %d, handler=%p, data=%p\n",
 	fd, handler, data);
 #ifdef _SQUID_MSWIN_
-	for (c = sd_table[fd].close_handler; c; c = c->next)
+    for (c = sd_table[fd].close_handler; c; c = c->next)
 	assert(c->handler != handler || c->data != data);
     new->handler = handler;
     new->data = data;
@@ -842,9 +764,9 @@
     debug(5, 5) ("comm_remove_close_handler: FD %d, handler=%p, data=%p\n",
 	fd, handler, data);
 #ifdef _SQUID_MSWIN_
-	for (p = sd_table[fd].close_handler; p != NULL; last = p, p = p->next)
+    for (p = sd_table[fd].close_handler; p != NULL; last = p, p = p->next)
 #else
-	for (p = fd_table[fd].close_handler; p != NULL; last = p, p = p->next)
+    for (p = fd_table[fd].close_handler; p != NULL; last = p, p = p->next)
 #endif
 	if (p->handler == handler && p->data == data)
 	    break;		/* This is our handler */
@@ -869,11 +791,10 @@
     L.l_onoff = 0;		/* off */
     L.l_linger = 0;
     if (setsockopt(fd, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
+	debug(50, 0) ("commSetNoLinger: FD %d: %s\n", fd, xstrerror());
 #ifdef _SQUID_MSWIN_
-	debug(50, 0) ("commSetNoLinger: FD %d: %s\n", fd, wsastrerror(WSAGetLastError()));
     sd_table[fd].flags.nolinger = 1;
 #else
-	debug(50, 0) ("commSetNoLinger: FD %d: %s\n", fd, xstrerror());
     fd_table[fd].flags.nolinger = 1;
 #endif
 }
@@ -900,9 +821,9 @@
     int flags;
     int dummy = 0;
 #ifdef _SQUID_MSWIN_
-    int nonblocking = TRUE;
-    if (ioctlsocket(fd, FIONBIO, (unsigned long*)&nonblocking) ==SOCKET_ERROR) {
-	debug(50, 0) ("commSetNonBlocking: FD %d: %s\n", fd, wsastrerror(WSAGetLastError()));
+    int nonblocking = 1;
+    if (ioctlsocket(fd, FIONBIO, (unsigned long *) &nonblocking) < 0) {
+	debug(50, 0) ("commSetNonBlocking: FD %d: %s\n", fd, xstrerror());
 	return COMM_ERROR;
     }
     sd_table[fd].flags.nonblocking = 1;
@@ -926,9 +847,9 @@
     int flags;
     int dummy = 0;
 #ifdef _SQUID_MSWIN_
-	int nonblocking=0;
-    if (ioctlsocket(fd, FIONBIO, (unsigned long*)&nonblocking) ==SOCKET_ERROR) {
-	debug(50, 0) ("commSetNonBlocking: FD %d: %s\n", fd, wsastrerror(WSAGetLastError()));
+    int nonblocking = 0;
+    if (ioctlsocket(fd, FIONBIO, (unsigned long *) &nonblocking) < 0) {
+	debug(50, 0) ("commSetNonBlocking: FD %d: %s\n", fd, xstrerror());
 	return COMM_ERROR;
     }
     sd_table[fd].flags.nonblocking = 0;
@@ -971,12 +892,11 @@
 }
 #endif
 
-
 void
 comm_init(void)
 {
 #ifdef _SQUID_MSWIN_
-    sd_table =(sde*) xcalloc(Squid_MaxFD, sizeof(sde));
+    sd_table = (sde *) xcalloc(Squid_MaxFD, sizeof(sde));
 #endif
     fd_table = xcalloc(Squid_MaxFD, sizeof(fde));
     /* XXX account fd_table */
@@ -998,11 +918,7 @@
 	fd, (int) state->offset, state->size);
 
     nleft = state->size - state->offset;
-#ifdef _SQUID_MSWIN_
-    len = send(fd, state->buf + state->offset, nleft);
-#else
     len = write(fd, state->buf + state->offset, nleft);
-#endif
     debug(5, 5) ("commHandleWrite: write() returns %d\n", len);
     fd_bytes(fd, len, FD_WRITE);
     Counter.syscalls.sock.writes++;
@@ -1011,58 +927,45 @@
 	/* Note we even call write if nleft == 0 */
 	/* We're done */
 	if (nleft != 0)
-	    debug(5, 1) ("commHandleWrite: FD %d: write failure: connection closed with %d bytes remaining.\n", fd, nleft);
+	    debug(5, 1)
+		
+		("commHandleWrite: FD %d: write failure: connection closed with %d bytes remaining.\n",
+		fd, nleft);
 	CommWriteStateCallbackAndFree(fd, nleft ? COMM_ERROR : COMM_OK);
     } else if (len < 0) {
 	/* An error */
 #ifdef _SQUID_MSWIN_
-	    if (sd_table[fd].flags.socket_eof) {
-	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
-		fd, wsastrerror(WSAGetLastError()));
+	if (sd_table[fd].flags.socket_eof) {
 #else
-	    if (fd_table[fd].flags.socket_eof) {
+	if (fd_table[fd].flags.socket_eof) {
+#endif
 	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
 		fd, xstrerror());
-#endif
 	    CommWriteStateCallbackAndFree(fd, COMM_ERROR);
-#ifdef _SQUID_MSWIN_
 	} else if (ignoreErrno(errno)) {
+#ifdef _SQUID_MSWIN_
 	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
-		fd, wsastrerror(WSAGetLastError()));
-		commSetSelectS(fd,COMM_SELECT_WRITE, commHandleWrite,state, 0);
-	} else {
-	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
-		fd, wsastrerror(WSAGetLastError()));
-	    CommWriteStateCallbackAndFree(fd, COMM_ERROR);
-	}
+		fd, xstrerror());
+	    commSetSelectS(fd, COMM_SELECT_WRITE, commHandleWrite, state, 0);
 #else
-	} else if (ignoreErrno(errno)) {
 	    debug(50, 10) ("commHandleWrite: FD %d: write failure: %s.\n",
 		fd, xstrerror());
-	    commSetSelect(fd,
-		COMM_SELECT_WRITE,
-		commHandleWrite,
-		state,
-		0);
+	    commSetSelect(fd, COMM_SELECT_WRITE, commHandleWrite, state, 0);
+#endif
 	} else {
 	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
 		fd, xstrerror());
 	    CommWriteStateCallbackAndFree(fd, COMM_ERROR);
 	}
-#endif
     } else {
 	/* A successful write, continue */
 	state->offset += len;
 	if (state->offset < state->size) {
 	    /* Not done, reinstall the write handler and write some more */
 #ifdef _SQUID_MSWIN_
-	    commSetSelectS(fd,COMM_SELECT_WRITE, commHandleWrite,state,0);
+	    commSetSelectS(fd, COMM_SELECT_WRITE, commHandleWrite, state, 0);
 #else
-	    commSetSelect(fd,
-		COMM_SELECT_WRITE,
-		commHandleWrite,
-		state,
-		0);
+	    commSetSelect(fd, COMM_SELECT_WRITE, commHandleWrite, state, 0);
 #endif
 	} else {
 	    CommWriteStateCallbackAndFree(fd, COMM_OK);
@@ -1075,12 +978,13 @@
 /* Select for Writing on FD, until SIZE bytes are sent.  Call
  * * HANDLER when complete. */
 void
-comm_write(int fd, char *buf, int size, CWCB * handler, void *handler_data, FREE * free_func)
+comm_write(int fd, char *buf, int size, CWCB * handler, void *handler_data,
+    FREE * free_func)
 {
 #ifdef _SQUID_MSWIN_
-	CommWriteStateData *state = sd_table[fd].rwstate;
+    CommWriteStateData *state = sd_table[fd].rwstate;
 #else
-	CommWriteStateData *state = fd_table[fd].rwstate;
+    CommWriteStateData *state = fd_table[fd].rwstate;
 #endif
     debug(5, 5) ("comm_write: FD %d: sz %d: hndl %p: data %p.\n",
 	fd, size, handler, handler_data);
@@ -1095,9 +999,9 @@
     }
     assert(state == NULL);
 #ifdef _SQUID_MSWIN_
-	sd_table[fd].rwstate = state = (CommWriteStateData*)xcalloc(1, sizeof(CommWriteStateData));
+    sd_table[fd].rwstate = state = xcalloc(1, sizeof(CommWriteStateData));
 #else
-	fd_table[fd].rwstate = state = xcalloc(1, sizeof(CommWriteStateData));
+    fd_table[fd].rwstate = state = xcalloc(1, sizeof(CommWriteStateData));
 #endif
     state->buf = buf;
     state->size = size;
@@ -1124,26 +1028,6 @@
  * hm, this might be too general-purpose for all the places we'd
  * like to use it.
  */
-#ifdef _SQUID_MSWIN_
-int
-WSAignoreErrno(int err)
-{
-    err=WSAGetLastError();
-    errno = err;
-    switch (err) {
-    case WSAEINPROGRESS:
-    case WSAEWOULDBLOCK:
-    case WSAEALREADY:
-	case WSATRY_AGAIN:
-	return 1;
-    default:
-	return 0;
-    }
-    /* NOTREACHED */
-}
-
-#else
-
 int
 ignoreErrno(int ierrno)
 {
@@ -1164,7 +1048,6 @@
     }
     /* NOTREACHED */
 }
-#endif
 
 void
 commCloseAllSockets(void)
@@ -1176,10 +1059,11 @@
     fde *F = NULL;
 #endif
     PF *callback;
-    for (fd = 0; fd <= Biggest_FD; fd++) {
 #ifdef _SQUID_MSWIN_
+    for (fd = 0; fd <= Biggest_SD; fd++) {
 	F = &sd_table[fd];
 #else
+    for (fd = 0; fd <= Biggest_FD; fd++) {
 	F = &fd_table[fd];
 #endif
 	if (!F->flags.open)
@@ -1189,13 +1073,15 @@
 	if (F->flags.ipc)	/* don't close inter-process sockets */
 	    continue;
 	if (F->timeout_handler) {
-	    debug(5, 5) ("commCloseAllSockets: FD %d: Calling timeout handler\n",
+	    debug(5,
+		5) ("commCloseAllSockets: FD %d: Calling timeout handler\n",
 		fd);
 	    callback = F->timeout_handler;
 	    F->timeout_handler = NULL;
 	    callback(fd, F->timeout_data);
 	} else {
-	    debug(5, 5) ("commCloseAllSockets: FD %d: calling comm_close()\n", fd);
+	    debug(5, 5) ("commCloseAllSockets: FD %d: calling comm_close()\n",
+		fd);
 	    comm_close(fd);
 	}
     }
Index: squid/src/comm_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm_select.c,v
retrieving revision 1.1.1.3.4.2.2.3
retrieving revision 1.1.1.3.4.2.2.3.2.1
diff -u -r1.1.1.3.4.2.2.3 -r1.1.1.3.4.2.2.3.2.1
--- squid/src/comm_select.c	28 Jul 2001 10:18:13 -0000	1.1.1.3.4.2.2.3
+++ squid/src/comm_select.c	27 Aug 2001 21:48:20 -0000	1.1.1.3.4.2.2.3.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: comm_select.c,v 1.1.1.3.4.2.2.3 2001/07/28 10:18:13 serassio Exp $
+ * $Id: comm_select.c,v 1.1.1.3.4.2.2.3.2.1 2001/08/27 21:48:20 tolsty Exp $
  *
  * DEBUG: section 5     Socket Functions
  *
@@ -475,13 +474,12 @@
 	    }
 	    if (revents & POLLNVAL) {
 		close_handler *ch;
-		debug(5, 0) ("WARNING: FD %d has handlers, but it's invalid.\n", fd);
+		debug(5, 0) ("WARNING: FD %d has handlers, but it's invalid.\n",
+		    fd);
 		debug(5, 0) ("FD %d is a %s\n", fd, fdTypeStr[F->type]);
 		debug(5, 0) ("--> %s\n", F->desc);
 		debug(5, 0) ("tmout:%p read:%p write:%p\n",
-		    F->timeout_handler,
-		    F->read_handler,
-		    F->write_handler);
+		    F->timeout_handler, F->read_handler, F->write_handler);
 		for (ch = F->close_handler; ch; ch = ch->next)
 		    debug(5, 0) (" close handler: %p\n", ch->handler);
 		if (F->close_handler) {
@@ -550,21 +548,19 @@
 	fd = fds[i];
 #ifdef _SQUID_MSWIN_
 	if (sd_table[fd].read_handler) {
-	    FD_SET((SOCKET) fd, &read_mask);
 #else
 	if (fd_table[fd].read_handler) {
-	    FD_SET(fd, &read_mask);
 #endif
+	    FD_SET(fd, &read_mask);
 	    if (fd > maxfd)
 		maxfd = fd;
 	}
 #ifdef _SQUID_MSWIN_
 	if (sd_table[fd].write_handler) {
-	    FD_SET((SOCKET) fd, &write_mask);
 #else
 	if (fd_table[fd].write_handler) {
-	    FD_SET(fd, &write_mask);
 #endif
+	    FD_SET(fd, &write_mask);
 	    if (fd > maxfd)
 		maxfd = fd;
 	}
@@ -720,11 +716,11 @@
 	FD_ZERO(&readsds);
 	FD_ZERO(&writesds);
 	FD_ZERO(&errsds);
-	xmemcpy(&readsds, &global_readsds,sizeof(global_readsds));
-	xmemcpy(&writesds, &global_writesds,sizeof(global_writesds));
-	xmemcpy(&errsds, &global_writesds,sizeof(global_writesds));
+	xmemcpy(&readsds, &global_readsds, sizeof(global_readsds));
+	xmemcpy(&writesds, &global_writesds, sizeof(global_writesds));
+	xmemcpy(&errsds, &global_writesds, sizeof(global_writesds));
 	for (j = 0; j < (int) readsds.fd_count; j++) {
-	    fd=readsds.fd_array[j];
+	    fd = readsds.fd_array[j];
 	    switch (commDeferRead(fd)) {
 	    case 0:
 		break;
@@ -798,7 +794,7 @@
 	}
 	if (msec > MAX_POLL_TIME)
 	    msec = MAX_POLL_TIME;
-#if defined(_SQUID_OS2_) || defined(_SQUID_MSWIN_)
+#if defined(_SQUID_OS2_)
 	if (msec < 0)
 	    msec = MAX_POLL_TIME;
 #endif
@@ -811,13 +807,12 @@
 #else
 	    num = select(maxfd, &readfds, &writefds, NULL, &poll_time);
 #endif
-		Counter.select_loops++;
+	    Counter.select_loops++;
 	    if (num >= 0)
 		break;
 	    if (ignoreErrno(errno))
 		break;
-	    debug(50, 0) ("comm_select: select failure: %s\n",
-		xstrerror());
+	    debug(50, 0) ("comm_select: select failure: %s\n", xstrerror());
 #ifdef _SQUID_MSWIN_
 	    examine_select(&readsds, &writesds);
 #else
@@ -842,7 +837,7 @@
 	/* Scan return fd masks for ready descriptors */
 #ifdef _SQUID_MSWIN_
 	for (j = 0; j < (int) readsds.fd_count; j++) {
-		fd=readsds.fd_array[j];
+	    fd = readsds.fd_array[j];
 #else
 	fdsp = (fd_mask *) & readfds;
 	maxindex = howmany(maxfd, FD_MASK_BITS);
@@ -902,20 +897,20 @@
 		    if (commCheckHTTPIncoming)
 			comm_select_http_incoming();
 		}
-	}
+	    }
 #ifdef _SQUID_MSWIN_
-	for (j = 0; j < (int) errsds.fd_count; j++) {
-		fd=errsds.fd_array[j];
+	    for (j = 0; j < (int) errsds.fd_count; j++) {
+		fd = errsds.fd_array[j];
 		F = &sd_table[fd];
 		if ((hdl = F->write_handler)) {
-			F->write_handler = NULL;
-			commUpdateWriteBitsS(fd, NULL);
-			hdl(fd, F->write_data);
-			Counter.select_fds++;
+		    F->write_handler = NULL;
+		    commUpdateWriteBitsS(fd, NULL);
+		    hdl(fd, F->write_data);
+		    Counter.select_fds++;
 		}
-	}
-	for (j = 0; j < (int) writesds.fd_count; j++) {
-		fd=writesds.fd_array[j];
+	    }
+	    for (j = 0; j < (int) writesds.fd_count; j++) {
+		fd = writesds.fd_array[j];
 #else
 	}
 	fdsp = (fd_mask *) & writefds;
@@ -969,9 +964,9 @@
 		    if (commCheckHTTPIncoming)
 			comm_select_http_incoming();
 #ifndef _SQUID_MSWIN_
-	    }
-#endif
 		}
+#endif
+	    }
 	}
 	if (callicp)
 	    comm_select_icp_incoming();
@@ -982,9 +977,9 @@
 #if DELAY_POOLS
 	while ((fd = commGetSlowFd()) != -1) {
 #ifdef _SQUID_MSWIN_
-		F = &sd_table[fd];
+	    F = &sd_table[fd];
 #else
-		F = &fd_table[fd];
+	    F = &fd_table[fd];
 #endif
 	    debug(5, 6) ("comm_select: slow FD %d selected for reading\n", fd);
 	    if ((hdl = F->read_handler)) {
@@ -1046,8 +1041,7 @@
     zero_tv.tv_sec = 0;
     zero_tv.tv_usec = 0;
     cachemgrRegister("comm_incoming",
-	"comm_incoming() stats",
-	commIncomingStats, 0, 1);
+	"comm_incoming() stats", commIncomingStats, 0, 1);
     FD_ZERO(&global_readfds);
     FD_ZERO(&global_writefds);
     nreadfds = nwritefds = 0;
@@ -1095,13 +1089,9 @@
 	debug(5, 0) ("FD %d: %s\n", fd, xstrerror());
 	debug(5, 0) ("WARNING: FD %d has handlers, but it's invalid.\n", fd);
 	debug(5, 0) ("FD %d is a %s called '%s'\n",
-	    fd,
-	    fdTypeStr[F->type],
-	    F->desc);
+	    fd, fdTypeStr[F->type], F->desc);
 	debug(5, 0) ("tmout:%p read:%p write:%p\n",
-	    F->timeout_handler,
-	    F->read_handler,
-	    F->write_handler);
+	    F->timeout_handler, F->read_handler, F->write_handler);
 	for (ch = F->close_handler; ch; ch = ch->next)
 	    debug(5, 0) (" close handler: %p\n", ch->handler);
 	if (F->close_handler) {
@@ -1127,14 +1117,14 @@
     int fd;
 #ifdef _SQUID_MSWIN_
     sde *F = NULL;
-    int	j;
+    int j;
 #else
     fde *F = NULL;
 #endif
     PF *callback;
 #ifdef _SQUID_MSWIN_
     for (j = 0; j < (int) readsds.fd_count; j++) {
-	fd=readsds.fd_array[j];
+	fd = readsds.fd_array[j];
 	F = &sd_table[fd];
 #else
     for (fd = 0; fd <= Biggest_FD; fd++) {
@@ -1159,7 +1149,7 @@
     }
 #ifdef _SQUID_MSWIN_
     for (j = 0; j < (int) writesds.fd_count; j++) {
-	fd=writesds.fd_array[j];
+	fd = writesds.fd_array[j];
 	F = &sd_table[fd];
 	if (!F->flags.open)
 	    continue;
@@ -1194,21 +1184,27 @@
     storeAppendPrintf(sentry, "\n");
     storeAppendPrintf(sentry, "Histogram of events per incoming socket type\n");
 #ifdef HAVE_POLL
-    storeAppendPrintf(sentry, "ICP Messages handled per comm_poll_icp_incoming() call:\n");
+    storeAppendPrintf(sentry,
+	"ICP Messages handled per comm_poll_icp_incoming() call:\n");
 #else
-    storeAppendPrintf(sentry, "ICP Messages handled per comm_select_icp_incoming() call:\n");
+    storeAppendPrintf(sentry,
+	"ICP Messages handled per comm_select_icp_incoming() call:\n");
 #endif
     statHistDump(&f->comm_icp_incoming, sentry, statHistIntDumper);
 #ifdef HAVE_POLL
-    storeAppendPrintf(sentry, "DNS Messages handled per comm_poll_dns_incoming() call:\n");
+    storeAppendPrintf(sentry,
+	"DNS Messages handled per comm_poll_dns_incoming() call:\n");
 #else
-    storeAppendPrintf(sentry, "DNS Messages handled per comm_select_dns_incoming() call:\n");
+    storeAppendPrintf(sentry,
+	"DNS Messages handled per comm_select_dns_incoming() call:\n");
 #endif
     statHistDump(&f->comm_dns_incoming, sentry, statHistIntDumper);
 #ifdef HAVE_POLL
-    storeAppendPrintf(sentry, "HTTP Messages handled per comm_poll_http_incoming() call:\n");
+    storeAppendPrintf(sentry,
+	"HTTP Messages handled per comm_poll_http_incoming() call:\n");
 #else
-    storeAppendPrintf(sentry, "HTTP Messages handled per comm_select_http_incoming() call:\n");
+    storeAppendPrintf(sentry,
+	"HTTP Messages handled per comm_select_http_incoming() call:\n");
 #endif
     statHistDump(&f->comm_http_incoming, sentry, statHistIntDumper);
 }
@@ -1262,4 +1258,4 @@
 	nwritefds--;
     }
 }
-#endif COMM_SELECT_C
+#endif /* COMM_SELECT_C */
Index: squid/src/debug.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/debug.c,v
retrieving revision 1.1.1.3.4.1.2.3
retrieving revision 1.1.1.3.4.1.2.3.2.1
diff -u -r1.1.1.3.4.1.2.3 -r1.1.1.3.4.1.2.3.2.1
--- squid/src/debug.c	30 Jun 2001 18:42:07 -0000	1.1.1.3.4.1.2.3
+++ squid/src/debug.c	27 Aug 2001 21:48:20 -0000	1.1.1.3.4.1.2.3.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: debug.c,v 1.1.1.3.4.1.2.3 2001/06/30 18:42:07 serassio Exp $
+ * $Id: debug.c,v 1.1.1.3.4.1.2.3.2.1 2001/08/27 21:48:20 tolsty Exp $
  *
  * DEBUG: section 0     Debug Routines
  * AUTHOR: Harvest Derived
@@ -40,9 +39,13 @@
 static const char *debugLogTime(time_t);
 static void ctx_print();
 
+#ifdef _SQUID_MSWIN_
+extern LPCRITICAL_SECTION dbg_mutex;
+#endif
+
 #if STDC_HEADERS
 void
-_db_print(const char *format,...)
+_db_print(const char *format, ...)
 {
 #if defined(__QNX__)
     va_list eargs;
@@ -73,12 +76,55 @@
 
     if (debug_log == NULL)
 	return;
+
+#ifdef _SQUID_MSWIN_
+#if !defined(UNLINK_DAEMON) && !defined(PINGER)
+    /* multiple threads may call this simultaneously */
+    if (!dbg_mutex) {
+	HMODULE krnl_lib = LoadLibrary("Kernel32.dll");
+	BOOL(FAR WINAPI *
+	    InitializeCriticalSectionAndSpinCount) (LPCRITICAL_SECTION, DWORD)
+	    = NULL;
+
+	if (krnl_lib)
+	    (FARPROC) InitializeCriticalSectionAndSpinCount =
+		GetProcAddress(krnl_lib,
+		"InitializeCriticalSectionAndSpinCount");
+	dbg_mutex = xcalloc(1, sizeof(CRITICAL_SECTION));
+
+	__try {
+	    if (InitializeCriticalSectionAndSpinCount) {
+		/* let multiprocessor systems EnterCriticalSection() fast */
+		if (!InitializeCriticalSectionAndSpinCount(dbg_mutex, 4000))
+		    RaiseException(STATUS_NO_MEMORY, 0, 0, NULL);
+	    } else
+		InitializeCriticalSection(dbg_mutex);
+	}
+	__except(STATUS_NO_MEMORY ==
+	    GetExceptionCode()? EXCEPTION_EXECUTE_HANDLER :
+	    EXCEPTION_CONTINUE_SEARCH) {
+	    if (debug_log) {
+		fprintf(debug_log,
+		    "FATAL: _db_print: can't initialize critical section\n");
+		fflush(debug_log);
+	    }
+	    fprintf(stderr,
+		"FATAL: _db_print: can't initialize critical section\n");
+	    if (krnl_lib)
+		FreeLibrary(krnl_lib);
+	    abort();
+	}
+	if (krnl_lib)
+	    FreeLibrary(krnl_lib);
+    }
+    EnterCriticalSection(dbg_mutex);
+#endif
+#endif
+
     /* give a chance to context-based debugging to print current context */
     if (!Ctx_Lock)
 	ctx_print();
-    snprintf(f, BUFSIZ, "%s| %s",
-	debugLogTime(squid_curtime),
-	format);
+    snprintf(f, BUFSIZ, "%s| %s", debugLogTime(squid_curtime), format);
 #if HAVE_SYSLOG
     /* level 0,1 go to syslog */
     if (_db_level <= 1 && opt_syslog_enable) {
@@ -103,6 +149,11 @@
 	vfprintf(stderr, f, args);
 #endif
     }
+#ifdef _SQUID_MSWIN_
+#if !defined(UNLINK_DAEMON) && !defined(PINGER)
+    LeaveCriticalSection(dbg_mutex);
+#endif
+#endif
 #if defined(__QNX__)
     va_end(eargs);
 #endif
@@ -216,7 +267,7 @@
 	i--;
 	snprintf(from, MAXPATHLEN, "%s.%d", debug_log_file, i - 1);
 	snprintf(to, MAXPATHLEN, "%s.%d", debug_log_file, i);
-	xrename(from, to);
+	rename(from, to);
     }
     /*
      * You can't rename open files on Microsoft "operating systems"
@@ -224,12 +275,12 @@
      */
 #ifdef _SQUID_MSWIN_
     if (debug_log != stderr)
-		fclose(debug_log);
+	fclose(debug_log);
 #endif
     /* Rotate the current log to .0 */
     if (Config.Log.rotateNumber > 0) {
 	snprintf(to, MAXPATHLEN, "%s.%d", debug_log_file, 0);
-	xrename(debug_log_file, to);
+	rename(debug_log_file, to);
     }
     /* Close and reopen the log.  It may have been renamed "manually"
      * before HUP'ing us. */
@@ -353,8 +404,7 @@
 static const char *ctx_get_descr(Ctx ctx);
 
 
-Ctx
-ctx_enter(const char *descr)
+Ctx ctx_enter(const char *descr)
 {
     Ctx_Current_Level++;
 
@@ -362,7 +412,8 @@
 	Ctx_Descrs[Ctx_Current_Level] = descr;
 
     if (Ctx_Current_Level == Ctx_Warn_Level) {
-	debug(0, 0) ("# ctx: suspiciously deep (%d) nesting:\n", Ctx_Warn_Level);
+	debug(0, 0) ("# ctx: suspiciously deep (%d) nesting:\n",
+	    Ctx_Warn_Level);
 	Ctx_Warn_Level *= 2;
     }
     return Ctx_Current_Level;
